import Test.QuickCheck

type Queue a = [a]
empty = []
add x q = q ++ [x]
isEmpty q = null q
front (x:q) = x
remove (x:q) = q

type Queue2 a = ([a], [a])
empty2 = ([],[])
add2 x (f,b) = (f, x:b)
isEmpty2 (f,b) = null f
front2 (x:f, b) = x
remove2 (x:f, b) = flipQ (f,b)

flipQ ([], b) = (reverse b, [])
flipQ q       = q


prop_inv_empty     = invariant empty2
prop_inv_remove q  = invariant q && not (isEmpty2 q) ==> invariant(remove2 q)
prop_inv_add x q   = invariant q ==> invariant (add2 x q)

invariant :: Queue2 Integer -> Bool
invariant (f,b) = not (null f) || null b
