import Test.QuickCheck

type Queue a = [a]
empty = []
add x q = q ++ [x]
isEmpty q = null q
front (x:q) = x
remove (x:q) = q

type Queue2 a = ([a], [a])
empty2 = ([],[])
add2 x (f,b) = flipQ (f, x:b)
isEmpty2 (f,b) = null f
front2 (x:f, b) = x
remove2 (x:f, b) = flipQ (f,b)

flipQ ([], b) = (reverse b, [])
flipQ q       = q


retrieve      :: Queue2 Integer -> Queue Integer
retrieve (f,b) = f ++ reverse b

invariant :: Queue2 Integer -> Bool
invariant (f,b) = not (null f) || null b

q `equiv` q' = invariant q && invariant q' && retrieve q == retrieve q'

prop_remove_add x q = invariant q && not (isEmpty2 q) ==> remove2 (add2 x q) `equiv` add2 x (remove2 q)
